export interface Hooks<T> {
    values: T[];
    deps: unknown[][];
    effects: (() => void | (() => void))[];
    cleanup: (() => void)[];
}
export declare function hooks<T>(config: {
    oncreate?: (h: Hooks<T>, c: Component, i: number) => T;
    onupdate?: (h: Hooks<T>, c: Component, i: number) => T;
}): T;
export declare abstract class Component extends HTMLElement {
    private updating;
    $root: ShadowRoot;
    hooks: Hooks<unknown>;
    protected abstract render(): void;
    protected connectedCallback(): void;
    protected disconnectedCallback(): void;
    update(): void;
    private affect;
}
