export const cssSymbol = Symbol("css");
const hasCSSSymbol = (value) => {
    return typeof value === "object" && value != null && cssSymbol in value;
};
const resolve = (value) => {
    if (typeof value === "number")
        return String(value);
    if (hasCSSSymbol(value))
        return value[cssSymbol];
    if (value instanceof URL)
        return value.href;
    throw new TypeError(`${value} is not supported type.`);
};
export const css = (strings, ...values) => ({
    [cssSymbol]: strings
        .slice(1)
        .reduce((acc, s, i) => acc + resolve(values[i]) + s, strings[0])
});
export const unsafeCSS = (css) => ({ [cssSymbol]: css });
//# sourceMappingURL=css.js.map