import { Context } from "./context";
import { HasCSSSymbol } from "./css";
export interface AttributeConverter<T> {
    (attr: string | null): T;
}
export declare function useAttribute(name: string): string | null;
export declare function useAttribute<T>(name: string, converter: AttributeConverter<T>): T;
export declare const useProperty: <T>(name: string) => T;
export declare const useDispatchEvent: <T>(name: string, eventInit?: EventInit) => (detail: T) => void;
export declare const useStyle: (cssCreator: () => HasCSSSymbol) => undefined;
export declare const useRef: <T>(initialValue: T | null) => {
    current: T | null;
};
export declare const useState: <T>(initialState: T | (() => T)) => [T, (t: T | ((s: T) => T)) => void];
export declare const useReducer: <S, A>(reducer: (state: S, action: A) => S, initialState: S) => [S, (action: A) => void];
export declare const useContext: <T>(context: Context<T>) => T | undefined;
export declare const useEffect: (handler: () => void | (() => void), deps: unknown[]) => undefined;
export declare const useMemo: <T>(fn: () => T, deps: unknown[]) => T;
export declare const useCallback: <A, R>(callback: (a: A) => R, deps: unknown[]) => (a: A) => R;
