export const REQUEST_CONSUME = "context:request-consume:" + String(Math.random()).slice(2);
export class Provider extends HTMLElement {
    constructor() {
        super();
        this.consumers = new Set();
        this.attachShadow({ mode: "open" }).appendChild(document.createElement("slot"));
    }
    connectedCallback() {
        this.addEventListener(REQUEST_CONSUME, e => {
            const { detail: { context, consumer, register } } = e;
            if (this.contextId === context.id) {
                e.stopPropagation();
                this.consumers.add(consumer);
                register(this);
            }
        });
    }
    unsubscribe(consumer) {
        this.consumers.delete(consumer);
    }
    get value() {
        return this._value;
    }
    set value(newValue) {
        if (this._value !== newValue) {
            this._value = newValue;
            this.consumers.forEach(c => c.update());
        }
    }
}
//# sourceMappingURL=provider.js.map